
; this is a DPMI TSR in MZ file format.
; to be assembled with JWasm/Masm.
; it works in NTVDM only
; it loads VDD HXVDD.DLL, hooks int 31h protected-mode and routes Int 31h,
; ax=05xxh to HXVDD.DLL.
; copyright Japheth 2007

        .386
        option casemap:none
        option proc:private
        
        include dpmi.inc
        include macros.inc

?HOOK2F	equ 1

CR		equ 13
LF		equ 10

_TEXT16 segment word use16 public 'CODE'

if ?HOOK2F
oldint2f dd 0
oldentry dd 0
int2f proc
	cmp ax,1687h
    jz @F
    jmp cs:[oldint2f]
@@:
	pushf
	call cs:[oldint2f]
    and ax,ax
    jnz @F
    mov word ptr [oldentry+0],di
    mov word ptr [oldentry+2],es
	push cs
    pop es
    mov di,offset myentry
@@:
    iret
myentry:
if 1
	test al,1
    jnz @F
    stc
    retf
@@:
	jmp cs:[oldentry]
else
	mov cs:[bMode],al
	call cs:[oldentry]
    jc @F
    push bp
    mov bp,sp
    push bx
    push ax
    mov bx,[bp+4]
    mov ax,2
    int 31h
    mov [bp+4],ax
    pop ax
    pop bx
    pop bp
@@:
    retf
bMode    db 0
endif
int2f endp

endres label byte

endif

getnum proc
	xor dx,dx
@@:
    cmp byte ptr es:[bx],' '
    jnz nextchar
    inc bx
    jmp @B
nextchar:
    mov al,es:[bx]
    cmp al,'0'
    jb done
    cmp al,'9'
    ja done
    inc bx
    sub al,'0'
    mov ah,0
    push ax
    mov ax,10
    mul dx
    mov dx,ax
    pop ax
    add dx,ax
    jmp nextchar
done:
	mov ax,dx
	ret
getnum endp

start:
	push cs
    pop ds

    assume ds:_TEXT16

    mov ax, ss
    mov cx, es
    sub ax, cx
    mov bx, sp
    shr bx, 4
    add bx, ax          ;release unused DOS memory
    sub ax, 10h
    shl ax, 4
    add ax, sp
    mov cx, cs
    mov ss, cx
    assume ss:_TEXT16
    mov sp, ax			;set CS=SS=DS
    
    mov ah, 4Ah
    int 21h

	or eax,-1			;set hiword of eax to -1
	mov bx,80h
    mov cl,es:[bx]
    and cl,cl
    jz noparm
    mov ch,0
    mov si,cx
    mov es:[si+bx+1],ch
    mov ah,0
    inc bx
nextchar:
   	mov al,es:[bx]
    inc bx
    cmp al,0
   	jz parmdone
    .if (al == '/') || (al == '-')
    	mov ah,al
    .elseif (ah)
    	mov ah,0
        or al,20h
        cmp al,'u'
        jnz @F
        or [bFlags], FL_UNINST
        jmp nextchar
@@:
		cmp al,'m'
		jnz paramerr
        call getnum
        and ax,ax
        jz paramerr		;0 < value < 4096?
        cmp ax,4096
        jnc paramerr
        shl eax,16		;save -m parameter in hiword eax
    .else
    	mov ah,0
    .endif
    jmp nextchar
parmdone:
noparm:
	mov bp,es			;save PSP in BP
    mov es,es:[2Ch]		;release environment
    mov ah,49h
    int 21h
    
    mov ax, 1687h       ;DPMI host installed?
    int 2Fh
    and ax, ax
    jnz nohost
    
    push es             ;save DPMI entry address
    push di
    and si,si           ;requires host client-specific DOS memory?
    jz nomemneeded
	add bp, 8
    mov es, bp
    cmp si, 8			;is it <= 80h bytes? (then we use the PSP)
    jbe nomemneeded
    mov bx, si
    mov ah, 48h         ;alloc DOS memory
    int 21h
    jc nomem
    mov es, ax
    xor si, si
nomemneeded:
    
    mov ax,3306h		;running in NTVDM?
    int 21h
    cmp bx,3205h
    jnz nontvdm

	test [bFlags],FL_UNINST
    jnz @F

	push es
    push si
    mov si,offset szHXVDD		;DS:SI -> "HXVDD.DLL"
    mov bx,offset szDispatch	;??:BX -> "Dispatch"
    mov di,offset szInit		;??:DI -> "Init"
    push ds
    pop es
    db 0c4h, 0c4h, 58h, 0
    pop si
    pop es
    jc loadfail
@@:
	mov cx,_TEXT32
    mov ds,cx
	assume ds:_TEXT32

    mov [hVdd],ax

    mov bp, sp
    mov ax, 0001        ;start a 32-bit client
    call far ptr [bp]   ;initial switch to protected-mode
    jc initfailed

;--- now in protected-mode

	test [bFlags],FL_UNINST
    jz install

;--- uninstall
;--- get the int 31h vector

    mov bl, 31h
    mov ax, 0204h
    int 31h
    mov fs, cx				;fs holds _TEXT32 of resident HXNTVDM
    assume fs:_TEXT32
    cmp fs:[dwSig], "HXNT"	;is there a HXNTVDM installed?
    jnz uninsterr

;--- restore the saved vector 
    
    mov edx, dword ptr fs:[oldint31+0]
    mov cx, word ptr fs:[oldint31+4]
    mov bl,31h
    mov ax, 0205h
    int 31h

if ?HOOK2F
    mov bx, fs:[wPSP]
    mov ax, 6
    int 31h
    mov bx,cx
    shl bx,12
    shr dx,4
    or bx,dx
    add bx,10h
    mov ax,2
    int 31h
	push ds
    mov ds, ax
    mov dx, word ptr ds:[oldint2f+0]
    mov cx, word ptr ds:[oldint2f+2]
    mov bl, 2Fh
    mov ax, 0201h
    int 31h
    pop ds
endif

;--- unload HXVDD

	mov ax,fs:[hVdd]
    db 0c4h, 0c4h, 58h, 01h

;--- terminate PSP of resident HXNTVDM
    
    push es
	mov bx, fs:[wPSP]
    mov ah, 50h			;set PSP
    int 21h
    mov ah, 00h			;kill PSP
    int 21h
    pop bx
    mov ah, 50h			;restore PSP of current HXNTVDM
    int 21h

;--- display msg that uninstall succeeded

    mov dx, offset dMsg11
    push cs
    pop	ds
    mov ah, 9
    int 21h
    
    mov ax, 4C00h
    int 21h
    
install:

;--- si = additional paragraphs for resident size (0-8)

	push si

	mov [wPSP], es		;save PSP
    
;--- get current int 31h vector
    
	mov	bl,31h
    mov ax,0204h
    int 31h
    mov dword ptr [oldint31+0],edx
    mov word ptr [oldint31+4],cx
    
;--- test if current int 31h owner is a HXNTVDM

    mov fs,cx
    assume fs:_TEXT32
    cmp fs:[dwSig], "HXNT"
    jz insterr
                        
    mov cx,1            ;get a descriptor for the 32-bit code segment
    mov ax,0
    int 31h
    jc dpmierr
    push ax

	mov bx,0
    mov cx,1000h
    mov ax,0501h		;alloc 1 page extended memory
    int 31h
    jc dpmierr
    
    mov dx,cx
    mov cx,bx
    pop bx
    
    mov ax,7            ;set base
    int 31h
    or dx,-1
    xor cx,cx
    mov ax,8            ;set limit
    int 31h

;--- copy HXNTVDM's resident part to extended memory

    mov es,bx
    mov cx,1000h/4
    xor di,di
    xor si,si
    rep movsd

    mov cx,cs
    lar cx,cx
    shr cx,8
    or  ch,40h          ;create a 32bit CS
    mov ax,9
    int 31h

;--- now set new int 31h vector

	mov		bl,31h
	mov		ecx,es
    mov     edx,offset int31
    mov     ax,0205h
    int     31h

;--- display msg that install succeeded

	push cs
    pop ds
    mov ah,9
    mov dx, offset dMsg12
    int 21h

;--- and go resident

	pop		si
if ?HOOK2F
	mov		bl,2Fh
	mov 	ax,0200h
    int		31h
    mov		word ptr ss:[oldint2f+0],dx
    mov		word ptr ss:[oldint2f+2],cx
    mov		dx,offset int2f
    mov		cx,_TEXT16
    mov		ax,0201h
    int		31h
    mov		si,offset endres
    add		si,15
    shr		si,4
    add		si,10h
else
	add		si,8
endif
	push	ss
    pop		es
    push	ss
    pop		ds
    sub		esp,sizeof RMCS
	mov	 	edi,esp
    xor     eax,eax
    mov     [edi].RMCS.rSSSP,eax     ;clear SS:SP
    mov     [edi].RMCS.rFlags,ax     ;clear flags
    mov     [edi].RMCS.rDX,si        ;set DX=8+x (no of paragraphs)
    mov     [edi].RMCS.rAX,3100h     ;set AX=3100h
    mov     bx,21h
    mov     cx,0
    mov     ax,0300h
    int     31h

;--- in case this call returns display error and exit

    mov dx, offset dErr8
error:    
    push cs
    pop	ds
    assume ds:_TEXT16
    mov ah, 9
    int 21h
    mov ax, 4C00h
    int 21h
nohost:
    mov dx, offset dErr1
    jmp error
loadfail:
	mov dx, offset dErr5
    jmp error
nontvdm:
	mov dx, offset dErr6
    jmp error
nomem:
    mov dx, offset dErr2
    jmp error
initfailed:
    mov dx, offset dErr3
    jmp error
dpmierr:
    mov dx, offset dErr4
    jmp error
dpmierr2:
    mov dx, offset dErr7
    jmp error
paramerr:
    mov dx, offset dMsg9
    jmp error
uninsterr:
    mov dx, offset dErr10
    jmp error
insterr:
    mov dx, offset dErr13
    jmp error

	align 2
bFlags db 0
	align 2

FL_UNINST equ 1

szHXVDD db "HXVDD.DLL",0
szDispatch db "Dispatch",0
szInit db "Init",0
dErr1 db "no DPMI host installed",CR,LF,'$'
dErr2 db "not enough DOS memory for client initialisation",CR,LF,'$'
dErr3 db "DPMI initialisation failed",CR,LF,'$'
dErr4 db "no LDT descriptors available",CR,LF,'$'
dErr5 db "loading HXVDD.DLL failed",CR,LF,'$'
dErr6 db "no NTVDM detected",CR,LF,'$'
dErr7 db "no extended memory",CR,LF,'$'
dErr8 db "going resident failed",CR,LF,'$'
dMsg9 db "HXNTVDM v1.0, copyright Japheth 2007",CR,LF
      db "cmdline switches are:",CR,LF
      db "-u: uninstall",CR,LF
      db "-m nnn: max DPMI memory in MB",CR,LF
      db '$'
dErr10 db "HXNTVDM not installed or doesn't own int 31h vector",CR,LF,'$'
dMsg11 db "HXNTVDM uninstalled",CR,LF,'$'
dMsg12 db "HXNTVDM installed",CR,LF,'$'
dErr13 db "HXNTVDM already installed",CR,LF,'$'

_TEXT16 ends

_TEXT32 segment para public 'CODE'

dwSig    dd "HXNT"
oldint31 df 0
wPSP     dw 0
hVdd     dw 0

		align 4

; this is the int 31h routine

int31   proc far

		cmp		ah,05
        jz		memfuncs
		cmp		ax,0401h
        jz		hostname
default:
        jmp     cs:[oldint31]
		align 4
memfuncs:
;		cmp		al,1
;		jb		default
hostname:
        push	ebp
        mov		ebp,eax
        mov		ax,cs:[hVdd]
        db 0c4h, 0c4h, 58h, 02h	;call HXVDD's Dispatch routine
        pop		ebp
        retf	4

int31   endp

_TEXT32 ends

STACK segment para use16 stack 'STACK'
	db 800h dup (?)
STACK ends

    END start

