
;--- a helper VDD for HX
;--- needs JWasm/Masm + Win32Inc
;--- copyright japheth 2007

        .386
        .MODEL FLAT, stdcall

WIN32_LEAN_AND_MEAN equ 1
		.nolist
        .nocref
        include windows.inc
        .cref
        .list
        include vddsvc.inc

?HOOKEXC	equ 1

;--- macros

;--- define a string constant

CStr macro y:req
local name
	.const
name db y,0
	.code
	exitm <offset name>
	endm

;--- printf debug output

@DbgOut	macro xx:REQ, parms:VARARG
ifdef _DEBUG
		pushad
		invoke wsprintf, addr g_szText, CStr(<xx>), parms
		invoke OutputDebugString, addr g_szText
        popad
endif
		endm

;--- string debug output

@DbgOutC macro xx
ifdef _DEBUG
		pushad
		invoke OutputDebugString, CStr(<xx>)
        popad
endif
		endm

;--- structure allocated for every DPMI client

CLIENT struct
pNext	dd ?
dwPSP	dd ?
pMem	dd ?
CLIENT ends

MEMITEM struct
pNext	dd ?
dwBase	dd ?
dwSize	dd ?	;size (rounded to 4 kB)
MEMITEM ends

;--- dpmi memory info (ax=500h)

MEMINFO struct
dwMaxBlock    dd ?            ;0	;in bytes
dwAvailVirtual dd ?           ;4	;in pages (max unlocked allocation)
dwMaxLockable dd ?            ;8	;in pages (max locked allocation)
dwTotalSpace  dd ?            ;12	;in pages
dwUnlocked    dd ?            ;16	;in pages (unlocked)
dwAvailPhys   dd ?            ;20
dwTotalPhys   dd ?            ;24
dwAvailSpace  dd ?            ;28	;in pages
dwAvailPageFile dd ?          ;32	;in pages
res           db 12 dup (?)
MEMINFO ends

        .data

hVDD		DD 0
g_pClient 	DD 0
g_hConOut	DD 0
g_dwMaxMem  DD 0
if ?HOOKEXC
g_pMonTeb	dd 0
g_oldexc	dd 0
endif

		.data?

ifdef _DEBUG        
g_szText db 256 dup (?)
endif

        .code

if 0
printf	proc c pStr:ptr BYTE, args:VARARG

local	dwWritten:dword
local	szText[256]:byte

		invoke wsprintf, addr szText, pStr, addr args
        lea ecx, dwWritten
        invoke WriteFile, g_hConOut, addr szText, eax, ecx, 0
        ret
		align 4
printf  endp
endif

;--- Init

Init    proc    stdcall

    	@DbgOutC <"HXVDD.Init enter",13,10>
        
        invoke getEAX
        shr eax,16		;max MB in ax
        shl eax,20		;max bytes in eax
        mov g_dwMaxMem, eax

    	@DbgOutC <"HXVDD.Init exit",13,10>
        ret
        align 4
Init    endp

dpmi401 proc uses ebx
		invoke setAX, 0
		invoke setCX, 0
		invoke setDX, 0
		invoke getES
		mov ebx, eax
		invoke getEDI
		invoke VdmMapFlat, ebx, eax, VDM_PM
		mov ebx, eax
		mov byte ptr [ebx+0],1	;major host version
		mov byte ptr [ebx+1],0	;minor host version
		mov dword ptr [ebx+2],"TNXH"
		mov dword ptr [ebx+6],"MDV"
		invoke setCF, 0		;clear carry flag
		ret
		align 4
dpmi401 endp

GetFreeAddressSpace proc uses ebx edi edi

local	mbi:MEMORY_BASIC_INFORMATION

		mov ebx, 10000h		;start with 0x10000
        xor edi, edi		;free address space
        xor esi, esi		;max free block
        
        .while (1)
			invoke VirtualQuery, ebx, addr mbi, sizeof mbi
            .break .if (!eax)
            .if (mbi.State == MEM_FREE)
            	.if (esi < mbi.RegionSize)
                	mov esi, mbi.RegionSize
                .endif
                add edi, mbi.RegionSize
            .endif
            add ebx, mbi.RegionSize
        .endw
        mov edx, esi
        mov eax, edi
		ret
        align 4
GetFreeAddressSpace endp

;--- ax=500h (DPMI get memory info)
;--- es:edi -> pointer to memory info block

dpmi500 proc uses ebx

local	gms:MEMORYSTATUS

		invoke getES
		mov ebx, eax
		invoke getEDI
		invoke VdmMapFlat, ebx, eax, VDM_PM
        mov ebx, eax
        
		invoke GlobalMemoryStatus, addr gms
        mov eax, gms.dwTotalPhys
        shr eax, 12
        mov [ebx].MEMINFO.dwTotalPhys, eax
        mov eax, gms.dwAvailPhys
        shr eax, 12
        mov [ebx].MEMINFO.dwAvailPhys, eax
        mov eax, gms.dwAvailPageFile
        shr eax, 12
        mov [ebx].MEMINFO.dwAvailPageFile, eax
        mov eax, gms.dwTotalVirtual
        sub eax, gms.dwAvailVirtual
        shr eax, 12
        mov [ebx].MEMINFO.dwUnlocked, eax
        mov eax, gms.dwTotalVirtual
        shr eax, 12
        mov [ebx].MEMINFO.dwTotalSpace, eax
if 0
        mov eax, gms.dwAvailVirtual
        shr eax, 12
        mov [ebx].MEMINFO.dwAvailVirtual, eax
endif
		invoke GetFreeAddressSpace

		shr eax, 12
        mov [ebx].MEMINFO.dwAvailSpace, eax
        
;--- edx = max free address space item
;--- max block = min(edx, dwAvailPhys+dwAvailPageFile)

;		mov eax, gms.dwAvailPhys
;		add eax, gms.dwAvailPageFile
		mov eax, gms.dwAvailVirtual
        cmp eax, edx
        jb @F
        mov eax, edx
@@:
		cmp eax, g_dwMaxMem
        jb @F
        mov eax, g_dwMaxMem
@@:        
        mov [ebx].MEMINFO.dwMaxBlock, eax
        shr eax, 12
        mov [ebx].MEMINFO.dwAvailVirtual, eax
        
		mov ecx, gms.dwAvailPhys
        shr ecx, 12
		cmp eax, ecx
        jb @F
        mov eax, ecx
@@:
        mov [ebx].MEMINFO.dwMaxLockable, eax

		invoke setCF, 0		;clear carry flag
		ret
		align 4
dpmi500 endp

;--- returns base in EAX

memalloc proc uses edi dwBase:dword, dwSize:dword, dwFlags:dword 

		mov ecx, dwSize
        add ecx, 4096-1
        and cx, 0F000h
        mov dwSize, ecx
        
        mov eax, dwFlags
		mov edx, MEM_RESERVE
		test dwFlags,1
		jz @F
        .if (dwBase)
			or edx, MEM_COMMIT
        .else
        	mov edx, MEM_COMMIT
        .endif
@@:
		invoke VirtualAlloc, dwBase, ecx, edx, PAGE_EXECUTE_READWRITE
		.if (!eax)
			mov ax,8012h		;linear memory unavailable
            stc
		.else
			mov edi, eax
			invoke LocalAlloc, LMEM_FIXED, sizeof MEMITEM
			.if (eax)
				mov [eax].MEMITEM.dwBase, edi
                mov ecx, dwSize
				mov [eax].MEMITEM.dwSize, edi
				mov ecx, [g_pClient]
				mov edx, [ecx].CLIENT.pMem
				mov [eax].MEMITEM.pNext, edx
				mov [ecx].CLIENT.pMem, eax
				@DbgOutC <"item added to linked list",13,10>
			.endif
			@DbgOut <"VirtualAlloc( %X, %X, MEM_COMMIT)=%X",13,10>, dwBase, dwSize, edi
			mov edx, dwFlags
			.if (edx & 1)
            	push edi
				mov ecx, dwSize
				shr ecx, 2
				mov eax, "TNXH"
				rep stosd
                pop edi
			.endif
	        mov eax, edi
            clc
		.endif
		ret
		align 4
memalloc endp

;--- ax=504h (DPMI linear memory alloc)
;--- try to alloc ecx bytes and fill it with "ABCD"
;--- ebx = linear address

dpmi504 proc uses ebx

local	rECX:dword

        invoke getEBX
        mov ebx, eax
        invoke getECX
        mov rECX, eax
        invoke getEDX
        
        invoke memalloc, ebx, rECX, eax
        jc error
        mov ebx, eax
		invoke setEBX, ebx	;set base address
		invoke setESI, ebx	;set handle
		invoke setCF, 0		;clear carry flag
		ret
error:
		invoke setAX, eax
		invoke setCF, 1		;set carry flag
        ret
		align 4
dpmi504 endp

;--- std DPMI memory alloc
;--- size in BX:CX
;--- returns handle in SI:DI, address in BX:CX

dpmi501 proc uses ebx

local	rEBX:dword
local	rESI:DWORD

		invoke getBX
        mov ebx,eax
        invoke getCX
        shl ebx,16
        mov bx,ax
        invoke memalloc, 0, ebx, 8+1
        jc error
        mov ebx, eax
        invoke setDI, ebx
        invoke setCX, ebx
        shr ebx, 16
        invoke setSI, ebx
        invoke setBX, ebx
		invoke setCF, 0		;clear carry flag
		ret
error:
		invoke setCF, 1		;set carry flag
		ret
        align 4
dpmi501 endp

;--- std DPMI memory free
;--- handle in SI:DI

dpmi502 proc uses ebx

		invoke getSI
        mov ebx, eax
        invoke getDI
        shl ebx, 16
        mov bx, ax			;handle in EBX
		mov edx, g_pClient
        lea ecx, [edx].CLIENT.pMem
        mov edx, [edx].CLIENT.pMem
        .while (edx)
        	.if (ebx == [edx].MEMITEM.dwBase)
            	mov eax, [edx].MEMITEM.pNext
                mov [ecx].MEMITEM.pNext, eax
                push edx
				invoke VirtualFree, [edx].MEMITEM.dwBase, 0, MEM_RELEASE
				@DbgOut <"VirtualFree( %X, 0, MEM_RELEASSE)=%X",13,10>, ebx, eax
                pop eax
	            invoke LocalFree, eax
                invoke setCF, 0
                jmp exit
            .endif
            mov ecx, edx
            mov edx, [edx].MEMITEM.pNext
        .endw
        invoke setCF, 1
exit:
		ret
        align 4
dpmi502 endp

CopyBlock proc dwDst:dword, dwSrc:dword, dwSize:dword                        

local	mbi:MEMORY_BASIC_INFORMATION

		pushad
        mov esi, dwSize
        mov ebx, dwSrc
        mov edi, dwDst
        .while (esi)
        	invoke VirtualQuery, ebx, addr mbi, sizeof mbi
            .break .if (!eax)
            mov ecx, mbi.RegionSize
            cmp ecx, esi
            jb @F
            mov ecx, esi
@@:
			push ecx
            .if (mbi.State == MEM_COMMIT)
	          	push edi
    	        push esi
    	        mov esi, ebx
				shr ecx, 2
				rep movsd
	   	        pop esi
				pop edi
            .else
            	invoke VirtualFree, edi, ecx, MEM_DECOMMIT
            .endif
            pop ecx
            add ebx, ecx
           	add edi, ecx
            sub esi, ecx
        .endw
exit:
		popad
		ret
        align 4
CopyBlock endp                        

;--- std DPMI memory realloc
;--- handle in SI:DI
;--- new size in BX:CX
;--- With Win32 Virtualxxx functions, there is no way
;--- to "increase" a region. So always alloc a new whole block
;--- and copy the content!

dpmi503 proc uses ebx esi edi

		invoke getSI
        mov ebx, eax
        invoke getDI
        shl ebx, 16
        mov bx, ax		;handle in EBX
		invoke getBX
        mov esi, eax
        invoke getCX
        shl esi, 16
        mov si, ax		;new size in ESI
        add esi, 4096-1	;align to pages
        and si, 0F000h
		mov edi, g_pClient
        mov edi, [edi].CLIENT.pMem
        .while (edi)
        	.if (ebx == [edi].MEMITEM.dwBase)
            
;--- handle found
;--- now just alloc a new, committed block
                
				invoke VirtualAlloc, 0, esi, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE
                and eax, eax
                jz error
                
;--- new block allocated, copy content from old block
;--- the old block may contain "holes", however, so be careful!

				mov ebx, eax
                mov ecx, esi
                mov edx, [edi].MEMITEM.dwSize
                cmp ecx, edx
                jb @F
                mov ecx, edx
@@:                
				invoke CopyBlock, ebx, [edi].MEMITEM.dwBase, ecx

;--- release old block

				invoke VirtualFree, [edi].MEMITEM.dwBase, 0, MEM_RELEASE
				mov [edi].MEMITEM.dwBase, ebx
				mov [edi].MEMITEM.dwSize, esi
				invoke setCX, ebx	; return new base in BX:CX
				invoke setDI, ebx	; return new handle in SI:DI
				shr ebx, 16
				invoke setBX, ebx
				invoke setSI, ebx
                invoke setCF, 0
				jmp exit
			.endif
			mov edi, [edi].MEMITEM.pNext
		.endw
error:
		invoke setCF, 1
exit:
		ret
		align 4
		
dpmi503 endp

;--- DPMI 506
;--- get page attributes
;--- esi = memory block handle
;--- ebx = offset within block
;--- ecx = number of pages
;--- es:edi = new attributes (bit 0: commit/decommit, bit 3: readwrite)

dpmi506 proc uses ebx edi

local	mbi:MEMORY_BASIC_INFORMATION
local	rECX:dword

        invoke getEBX
        mov ebx, eax
        invoke getECX
        mov rECX, eax
		invoke getES
		mov edi, eax
		invoke getEDX
		invoke VdmMapFlat, edi, eax, VDM_PM
        mov edi, eax
        invoke getESI
        and ax, 0F000h
        and bx, 0F000h
        add ebx, eax	;ebx holds linear address
        
        mov ecx, rECX
        .while (ecx)
            push ecx
           	invoke VirtualQuery, ebx, addr mbi, sizeof mbi
			@DbgOut <"VirtualQuery( %X)=%X",13,10>, ebx, eax
            pop ecx
            .break .if (!eax)
            mov edx, mbi.State
            xor eax, eax
            .if (edx & (PAGE_READWRITE or PAGE_EXECUTE_READWRITE))
            	or al,9
            .elseif (edx & (PAGE_READONLY or PAGE_EXECUTE_READ))
            	or al,1
            .endif
            stosw
            add ebx, 1000h
        	dec ecx
        .endw
        and ecx,ecx
        setnz al
        movzx eax,al
		invoke setCF, eax
		ret
		align 4
dpmi506 endp

;--- DPMI 507
;--- set page attributes
;--- esi = memory block handle
;--- ebx = offset within block
;--- ecx = number of pages
;--- es:edi = new attributes (bit 0: commit/decommit, bit 3: readwrite)

dpmi507 proc uses ebx esi

local	rECX:dword

        invoke getEBX
        mov ebx, eax
        invoke getECX
        mov rECX, eax
		invoke getES
		mov esi, eax
		invoke getEDX
		invoke VdmMapFlat, esi, eax, VDM_PM
        mov esi, eax
        invoke getESI
        and ax, 0F000h
        and bx, 0F000h
        add ebx, eax	;ebx holds linear address
        
        mov ecx, rECX
        .while (ecx)
        	lodsw
            push ecx
            .if (al & 1)
            	mov edx, PAGE_EXECUTE_READWRITE
                test al,8
                jnz @F
            	mov edx, PAGE_EXECUTE_READ
@@:             
            	invoke VirtualAlloc, ebx, 1000h, MEM_COMMIT, edx
				@DbgOut <"VirtualAlloc( %X, 1000, MEM_COMMIT)=%X",13,10>, ebx, eax
            .else
            	invoke VirtualFree, ebx, 1000h, MEM_DECOMMIT
				@DbgOut <"VirtualFree( %X, 1000, MEM_DECOMMIT)=%X",13,10>, ebx, eax
            .endif
            pop ecx
            .break .if (!eax)
            add ebx, 1000h
        	dec ecx
        .endw
        and ecx,ecx
        setnz al
        movzx eax,al
		invoke setCF, eax
		ret
		align 4
dpmi507 endp

;--- Dispatch

Dispatch proc stdcall

    	@DbgOutC <"HXVDD.Dispatch enter",13,10>
        
        invoke getEBP	;ebp holds value for EAX

        @DbgOut <"EAX=%X",13,10>, eax

        .if (ah == 5)
        	.if (al == 0)
	        	invoke dpmi500
        	.elseif (al == 1)
	        	invoke dpmi501
            .elseif (al == 2)
	        	invoke dpmi502
            .elseif (al == 3)
	        	invoke dpmi503
	        .elseif (al == 4)
	        	invoke dpmi504
	        .elseif (al == 6)
	        	invoke dpmi506
    	    .elseif (al == 7)
	        	invoke dpmi507
            .else
	            invoke setCF, 1
            .endif
        .elseif (ax == 0401h)
        	invoke dpmi401
        .else
            invoke setCF, 1
        .endif
        
    	@DbgOutC <"DEBXXVDD.Dispatch exit",13,10>
        ret
        align 4
Dispatch    endp

;--- PSP creation

pdbcreate proc dwPSP:dword

        @DbgOut <"HXVDD DOS PSP creation %X",13,10>,dwPSP
        invoke LocalAlloc, LMEM_FIXED or LMEM_ZEROINIT, sizeof CLIENT
        .if (eax)
	        mov ecx, [g_pClient]
            mov edx, dwPSP
            mov [eax].CLIENT.pNext, ecx
            mov [eax].CLIENT.dwPSP, edx
    	    mov [g_pClient], eax
        .endif
		ret
        align 4
pdbcreate endp

;--- release resources attached to a DOS PSP

DestroyClient proc uses ebx pClient:DWORD
		mov ebx, pClient
        mov ebx, [ebx].CLIENT.pMem
        .while (ebx)
        	push [ebx].MEMITEM.pNext
	        @DbgOut <"VirtualFree( %X)",13,10>, [ebx].MEMITEM.dwBase
            invoke VirtualFree, [ebx].MEMITEM.dwBase, 0, MEM_RELEASE
            invoke LocalFree, ebx
            pop ebx
        .endw
        invoke LocalFree, pClient
        ret
        align 4
DestroyClient endp

;--- PSP termination

pdbterm proc dwPSP:dword

        @DbgOut <"HXVDD DOS PSP termination %X",13,10>,dwPSP
        mov eax, g_pClient
        lea ecx, g_pClient
       	mov edx, dwPSP
        .while (eax && (edx != [eax].CLIENT.dwPSP))
           	mov ecx, eax
            mov eax, [eax].CLIENT.pNext
        .endw
        .if (eax)
        	mov edx, [eax].CLIENT.pNext
            mov [ecx].CLIENT.pNext, edx
            invoke DestroyClient, eax
        .endif
exit:
		ret
        align 4
pdbterm endp

if ?HOOKEXC

myexchandler proc
		@DbgOutC <"exception handler called",13,10>
		jmp [g_oldexc]
        align 4
myexchandler endp

InstallExcHook proc uses ebx
		invoke GetModuleHandle, CStr("NTVDM.EXE")
   	    .if (eax)
       		invoke GetProcAddress, eax, CStr("CurrentMonitorTeb")
            .if (eax)
            	mov g_pMonTeb, eax
                mov ecx,[eax]
                mov edx,[ecx]
                mov ebx,[edx+4]
                mov g_oldexc, ebx
                mov [edx+4],offset myexchandler
		        @DbgOut <"HXVDD: MonitorTeb=%X %X %X %X",13,10>, eax, ecx, edx, ebx
            .endif
        .endif
		ret
        align 4
InstallExcHook endp

UninstallExcHook proc uses ebx
		invoke GetModuleHandle, CStr("NTVDM.EXE")
        .if (eax)
        	invoke GetProcAddress, eax, CStr("CurrentMonitorTeb")
            .if (eax)
                mov ecx,[eax]
                mov edx,[ecx]
                mov ebx,[edx+4]
                .if (ebx == offset myexchandler)
                	mov eax,[g_oldexc]
	                mov [edx+4],eax
                .endif
            .endif
        .endif
		ret
        align 4
UninstallExcHook endp

ThreadInstall proc uses ebx
		invoke GetModuleHandle, CStr("NTVDM.EXE")
   	    .if (eax)
       		invoke GetProcAddress, eax, CStr("CurrentMonitorTeb")
            .if (eax)
            	mov g_pMonTeb, eax
                mov ecx,[eax]
                mov edx,[ecx]
                mov ebx,[edx+4]
;                mov g_oldexc, ebx
;                mov [edx+4],offset myexchandler
		        @DbgOut <"HXVDD Thread: MonitorTeb=%X %X %X %X",13,10>, eax, ecx, edx, ebx
            .endif
        .endif
		ret
        align 4
ThreadInstall endp

endif

;*** main proc ***

DllMain proc stdcall hInstance:dword, reason:dword, lpReserved:dword

        mov eax, reason
        .if (eax == DLL_PROCESS_ATTACH)
            @DbgOutC <"HXVDD process attach",13,10>
            mov eax, hInstance
            mov hVDD, eax
        	invoke GetStdHandle, STD_OUTPUT_HANDLE
            mov g_hConOut, eax
            invoke VDDInstallUserHook, hVDD, pdbcreate, pdbterm, 0, 0
if ?HOOKEXC
            invoke InstallExcHook
endif            
	        mov eax,1
        .elseif (eax == DLL_PROCESS_DETACH)
            @DbgOutC <"HXVDD process detach",13,10>
            invoke VDDDeInstallUserHook, hVDD
        .elseif (eax == DLL_THREAD_ATTACH)
if ?HOOKEXC        
        	invoke ThreadInstall
endif            
            @DbgOutC <"HXVDD thread attach",13,10>
        .elseif (eax == DLL_THREAD_DETACH)
            @DbgOutC <"HXVDD thread detach",13,10>
        .endif
        ret
        align 4
DllMain endp

        END DllMain

